#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "gun2fourteen4search.py">
#<abstract4xi abstract = "analyser fourteen for photos"/>
#<refer4xi reference = "analyse2photo4search.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
#<use4xi usage = "
# modify behaviour:
#    ack2function = False (default) <-- False to use function directly to shoot - blocks return TO MainProcess4Xi
#    ack2ready4cc = True  (default) <-- False, if module is not ready for command and control via queue and named pipe
#    ack2process = True   (default) <-- False, if Process4Xi is not used
#    ack2dummy = True     (default) <-- False, if DummyProcess4Xi is not used i.e. target function will be performed first before retuning
#"
#/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'gun2fourteen4search']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system
    import os
    import sys
    import signal
except:
    pass
try:                 # threading       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common
    import weakref
    import array
    import itertools
    from queue import Queue         
except:
    pass
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary
    import _multiprocessing
except:
    pass
try:                             # Python 
    from multiprocessing import TimeoutError, cpu_count
    from multiprocessing.dummy.connection import Pipe
except:
    pass
#"
#/>

# -------------------------------------------------------------------------------------------------
# Special Imports                          
# -------------------------------------------------------------------------------------------------
#<specialize4xi speciality = "
from threading import Lock, RLock, Semaphore, BoundedSemaphore
from threading import Event
#"
#/>



# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
try:    
    from dummyprocess4xi import DummyProcess4Xi
except:
    print("*** gun2fourteen4search: *** error: from dummyprocess4xi import DummyProcess4Xi ***")
    
try:    
    from process4xi import Process4Xi
except:
    print("*** gun2fourteen4search: *** error: from process4xi import Process4Xi ***")    
     
from shoot2fourteen4search import shoot2fourteen4search

from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global t2xi
global trace_object_count   
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
      
#"
#"/>
    
             
# -----------------------------------------------------------------------------------------------------
#<function4xi function = "gun2fourteen4search" usage = "
#   gun for Process4Xi-1
#   commands and control via queue and pipe
#"> 
# -----------------------------------------------------------------------------------------------------
       
def gun2fourteen4search(queue2work = None, channel2consume = None, channel2publish = None, path2fourteen = None):
    '''
    guns for Process4Xi-1
    '''    
       
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    print('=' *33)
    print("(STEP 0/33) OF GUN2FOURTEEN4SEARCH, START TIME: ", time4xi())      
    print('=' *33)
    # 11:03:08 01/20/15 FLE Standard Time 
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------       
    queue2work4fourteen = queue2work
    
    print('~' *33)
    print("(STEP 1/33) OF GUN2FOURTEEN4SEARCH, QUEUE2WORK4FOURTEEN: ", queue2work4fourteen)
    print('~' *33)
    # <queue4xi.Queue4Xi object at 0x029C5930>
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    channel2consume4fourteen = channel2consume
    print('~' *33)
    print("(STEP 2/33) OF GUN2FOURTEEN4SEARCH, CHANNEL2CONSUME4FOURTEEN: ", channel2consume4fourteen)
    print('~' *33)
    # <pipeconnection4xi.PipeConnection4Xi object at 0x029C5B10>
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    channel2publish4fourteen = channel2publish
    print('~' *33)
    print("(STEP 3/33) OF GUN2FOURTEEN4SEARCH, CHANNEL2PUBLISH4FOURTEEN: ", channel2publish4fourteen)
    print('~' *33)
    # <pipeconnection4xi.PipeConnection4Xi object at 0x029C54F0>

    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    path2search4fourteen = path2fourteen
    print('~' *33)
    print("(STEP 4/33) OF GUN2FOURTEEN4SEARCH, PATH2SEARCH4FOURTEEN: ", path2search4fourteen)
    print('~' *33)
    # F://temp//yophotos//test2fourteen//
    
    ack2process = True        
    # ---------------------------------------------------------------------------------------------    
    # GETTING COMMAND AND CONTROL (CC) FROM QUEUE - CALLER MUST HAVE PUT CC-DATA 
    # --------------------------------------------------------------------------------------------- 
    if not(queue2work4fourteen is None):    
        try:
            message2qet4fourteen = queue2work4fourteen.get()
            print("(STEP 5A/33) OF GUN2FOURTEEN4SEARCH - MESSAGE2QET4FOURTEEN GOT: ", message2qet4fourteen)  
            # <copy4xi>copy2fourteen</copy4xi>
                
            if message2qet4fourteen == "<copy4xi>copy2fourteen</copy4xi>":
                message2put4fourteen = "<roger4xi>roger2fourteen</roger4xi>"
                print("(STEP 5B/33) OF GUN2FOURTEEN4SEARCH - SET MESSAGE2PUT4FOURTEEN TO: ", message2put4fourteen) 
                # <roger4xi>roger2fourteen</roger4xi>
            else:
                print("(STEP 5C/33) OF GUN2FOURTEEN4SEARCH - *** UNREGONIZED MESSAGE, GOT: ", message2qet4fourteen)
                #           
                message2put4fourteen = "<negative4xi>negative2fourteen</negative4xi>"
                print("(STEP 5D/33) OF GUN2FOURTEEN4SEARCH - SET MESSAGE2PUT4FOURTEEN TO: ", message2put4fourteen)
                #              
        except:
            message2put4fourteen = "<negative4xi>negative2fourteen</negative4xi>"
            print("(STEP 5Z/33) OF GUN2FOURTEEN4SEARCH *** EXCEPTION, SET MESSAGE2PUT4FOURTEEN TO: ", message2put4fourteen)  
            ack2process = False
        # ---------------------------------------------------------------------------------------------    
        # PUTTING COMMAND AND CONTROL (CC) FROM QUEUE TO QUEUE- CALLER PREPARED TO GET CC-DATA  
        # --------------------------------------------------------------------------------------------- 
        print("(STEP 6A/33) OF GUN2FOURTEEN4SEARCH - TRYING TO PUT MESSAGE2PUT4FOURTEEN: ", message2put4fourteen)                                  
        # <roger4xi>roger2fourteen</roger4xi>
        try:         
            queue2work4fourteen.put(message2put4fourteen) 
            print('~' *33)
            print("(STEP 6B/33) OF GUN2FOURTEEN4SEARCH - PUT TO QUEUE2WORK4FOURTEEN: ", queue2work4fourteen, ' MESSAGE2PUT4FOURTEEN: ', message2put4fourteen)
            print('~' *33)
            # PUT TO QUEUE2WORK4FOURTEEN:  <queue4xi.Queue4Xi object at 0x029C5930>  MESSAGE2PUT4FOURTEEN:  <roger4xi>roger2fourteen</roger4xi>
                
        except:
            print("(STEP 6Z/33) OF GUN2FOURTEEN4SEARCH *** FAILED TO PUT TO QUEUE2WORK4FOURTEEN: ", queue2work4fourteen, ' MESSAGE2PUT4FOURTEEN: ', message2put4fourteen)
            ack2process = False
      
    if not(channel2consume4fourteen is None):
        # -----------------------------------------------------------------------------------------------    
        # RECEIVING COMMAND AND CONTROL (CC) MESSAGE FROM PIPE CONSUMER CHANNEL - CALLER HAS SENT CC-DATA 
        # -----------------------------------------------------------------------------------------------  
        print("(STEP 7A/33) OF GUN2FOURTEEN4SEARCH - TRYING TO RECEIVE FROM CHANNEL2CONSUME4FOURTEEN: ", channel2consume4fourteen)
        # TRYING TO RECEIVE FROM CHANNEL2CONSUME4FOURTEEN:  <pipeconnection4xi.PipeConnection4Xi object at 0x029C5B10>
        try:
            message2receive4fourteen = channel2consume4fourteen.recv()
            print("(STEP 7B/33) OF GUN2FOURTEEN4SEARCH - RECEIVED MESSAGE2RECEIVE4FOURTEEN: ", message2receive4fourteen)
            # RECEIVED MESSAGE2RECEIVE4FOURTEEN:  <copy4xi>copy2fourteen</copy4xi>
                
            if message2receive4fourteen == "<copy4xi>copy2fourteen</copy4xi>":
                message2send4fourteen = "<roger4xi>roger2fourteen</roger4xi>"
                print("(STEP 7C/33) OF GUN2FOURTEEN4SEARCH - SET MESSAGE2SEND4FOURTEEN: ", message2send4fourteen)
                # SET MESSAGE2SEND4FOURTEEN:  <roger4xi>roger2fourteen</roger4xi>
            else:
                message2send4fourteen = "<negative4xi>negative2fourteen</negative4xi>"
                print("(STEP 7D/33) OF GUN2FOURTEEN4SEARCH - SET MESSAGE2SEND4FOURTEEN: ", message2send4fourteen)        
        except:
            print("(STEP 7Z1/33) OF GUN2FOURTEEN4SEARCH - *** EXCEPTION WITH CHANNEL2CONSUME4FOURTEEN.RECV: ", channel2consume4fourteen.recv) 
            message2send4fourteen = "<negative4xi>negative2fourteen</negative4xi>"
            print("(STEP 7Z2/33) OF GUN2FOURTEEN4SEARCH - SET MESSAGE2SEND4FOURTEEN: ", message2send4fourteen)
            ack2process = False       
    else:
        print("(STEP 7E/33) OF GUN2FOURTEEN4SEARCH - SKIPPED RECEIVING FROM CHANNEL2CONSUME4FOURTEEN: ", channel2consume4fourteen)
        #     
                
    if not(channel2publish4fourteen is None):
        # -----------------------------------------------------------------------------------------------
        # SENDING COMMAND AND CONTROL (CC) MESSAGE TO THE PIPE'S PUBLISHER CHANNEL - CALLER TO RECEIVE IT 
        # -----------------------------------------------------------------------------------------------
        print("(STEP 8A/33) OF GUN2FOURTEEN4SEARCH - TRYING TO SEND COMMAND AND CONTROL TO CHANNEL2PUBLISHER4FOURTEEN: ", channel2publish4fourteen)
        # TRYING TO SEND COMMAND AND CONTROL TO CHANNEL2PUBLISHER4FOURTEEN:  <pipeconnection4xi.PipeConnection4Xi object at 0x029C54F0>
        try:         
            channel2publish4fourteen.send(message2send4fourteen)
            print("(STEP 8B/33) OF GUN2FOURTEEN4SEARCH - SENT MESSAGE2SEND4FOURTEEN: ", message2send4fourteen, " CHANNEL2PUBLISHER4FOURTEEN: ", channel2publish4fourteen)
            # SENT MESSAGE2SEND4FOURTEEN:  <roger4xi>roger2fourteen</roger4xi>  CHANNEL2PUBLISHER4FOURTEEN:  <pipeconnection4xi.PipeConnection4Xi object at 0x029C54F0>
        except:
            print("(STEP 8Z1/33) OF GUN2FOURTEEN4SEARCH - *** FAILED TO SEND MESSAGE2SEND4FOURTEEN: ", message2send4fourteen, " CHANNEL2PUBLISHER4FOURTEEN: ", channel2publish4fourteen) 
    else:
        print("(STEP 8C/33) OF GUN2FOURTEEN4SEARCH - SKIPPED SENDING COMMAND AND CONTROL TO THE PIPE'S PUBLISHER CHANNEL : ", channel2publish4fourteen)
        # 
        ack2process = False
        
    if ack2process is True:
        # -----------------------------------------------------------------------------------------------------------------    
        # USING THE DUMMY PROCESS TO SHOOT - THIS APPROACH ALLOWS FAST RETURN TO MainProcess4Xi ALLOWING CALLER TO CONTINUE  
        # -----------------------------------------------------------------------------------------------------------------      
        print("(STEP 10A/33) OF GUN2FOURTEEN4SEARCH - CREATING A DUMMY PROCESS4XI")  
        ack2dummy = False
        
        # -----------------------------------------------------------------------------------------    
        # CREATE THE DUMMY PROCESS OBJECT 
        # -----------------------------------------------------------------------------------------           
        try:
            dummy2fourteen= DummyProcess4Xi(target=shoot2fourteen4search, 
                                         args =(queue2work4fourteen,
                                                channel2consume4fourteen, channel2publish4fourteen,
                                                path2search4fourteen))
          
            print("(STEP 10B/33) OF GUN2FOURTEEN4SEARCH - CREATED DUMMY_PROCESS4XI OBJECT DUMMY2FOURTEEN: ", dummy2fourteen)
            # CREATED DUMMY_PROCESS4XI OBJECT DUMMY2FOURTEEN:  <DummyProcess4Xi(Thread-1, initial)>
            
            ack2dummy = True
        except:
            print("(STEP 10Z/33) OF GUN2FOURTEEN4SEARCH *** FAILED TO CREATE DUMMY_PROCESS4XI OBJECT DUMMY2FOURTEEN ***")
            ack2dummy = False
            
        # -----------------------------------------------------------------------------------------    
        # START THE DUMMY PROCESS OBJECT
        # -----------------------------------------------------------------------------------------              
        if ack2dummy is True:
            print("(STEP 10D/33) OF GUN2FOURTEEN4SEARCH - STARTING THE DUMMY PROCESS4XI TIME: ", time4xi())
            # STARTING THE DUMMY PROCESS4XI TIME:  11:03:09 01/20/15 FLE Standard Time
            ack2start = False
            try:      
                dummy2fourteen.start() 
                print("(STEP 10E/33) OF GUN2FOURTEEN4SEARCH - STARTED THE DUMMY PROCESS4XI DUMMY2FOURTEEN: ", dummy2fourteen)
                # STARTED THE DUMMY PROCESS4XI DUMMY2FOURTEEN:  <DummyProcess4Xi(Thread-1, started 4144)>
                
                #NOTES:
                # [1] function shoot2fourteen4search starts immediatelly AND lets this function to return to MainProcess4Xi 
                # [2] debug messages get mixed - dragon reason to use dragonized trace !
                # 
                #                 
                
                ack2start = True
            except:
                print("(STEP 10Z/33) OF GUN2FOURTEEN4SEARCH *** FAILED TO START THE DUMMY PROCESS4XI ***")

        else:
            print("(STEP 10G/33) OF GUN2FOURTEEN4SEARCH ** YIELDED STARTING THE DUMMY PROCESS4XI - ACK2DUMMY: ", ack2dummy)
            ack2start = False
             
    else:
        print("(STEP 10H/33) OF GUN2FOURTEEN4SEARCH ** YIELDED STARTING THE DUMMY PROCESS4XI ", time4xi())
                                
           
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     

    print('=' *33)
    print("(STEP 11/33) OF GUN2FOURTEEN4SEARCH - RETURNING TIME: ", time4xi())
    # OF GUN2FOURTEEN4SEARCH - RETURNING TIME:  11:03:09 01/20/15 FLE Standard Time
    print('=' *33)
    #  
    
    return
    
        
#</function4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# ROOT4XI\Studio4Xi\Python\3.3\txt\analyse2photo4search.txt
# dummy2fourteen\xml\ace-analyse2photo.xml
# dummy2fourteen\xml\reason-analyse2photo.xml
# dummy2fourteen\xml\sense-analyse2photo.xml
# 
#"
#>
#     
# 
# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.fourteenxi.com; www.yourfourteenxi.com; www.yourfourteenxi.org; www.fourteen2xi.com/; www.fourteen4xi.com/; www.fourteen8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of gun2fourteen4search.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
